/****************************************************************************

  clist.c : ꥹȽ

  Programmed by Shuji Nakamura  2000-08-19

****************************************************************************/


#include <stdio.h>  /* printf() */
#include <stdlib.h> /* malloc(), free() */
#include "clist.h"


void create_clist(int n, CLIST *cl)
{
  int i;

  cl->n = n;
  cl->next = (int *)malloc(n*sizeof(int));
  cl->tail = (int *)malloc(n*sizeof(int));
  cl->target = (int *)malloc(n*sizeof(int));

  for(i = 0; i < n; i++) {
    cl->next[i] = -1;
    cl->tail[i] = i;
    cl->target[i] = i;
  }
}


void free_clist(CLIST *cl)
{
  free(cl->next);
  free(cl->tail);
  free(cl->target);
}


void contract_clist(int s, int t, CLIST *cl)
{
  /* s ΥꥹȤ t ΥꥹȤղ */
  cl->next[cl->tail[t]] = s;
  cl->tail[t] = cl->tail[s];

  /* ѹ */
  cl->target[s] = t;
}


int get_target(int i, CLIST *cl)
{
  while(cl->target[i] != i)
    i = cl->target[i];
  return i;
}


int get_member(int i, int mbuf[], CLIST *cl)
{
  int j;

  if(is_contracted(i, cl))
    return -1;

  for(j = 0; i != -1; j++) {
    mbuf[j] = i;
    i = cl->next[i];
  }

  return j;
}


int is_contracted(int i, CLIST *cl)
{
  return cl->target[i] != i;
}


void print_clist(CLIST *cl)
{
  int i, t;

  for(i = 0; i < cl->n; i++) {
    printf("%d :", i);
    if(is_contracted(i, cl)) {
      printf(" ==> %d\n", cl->target[i]);
      continue;
    }

    t = cl->next[i];
    while(t != -1) {
      printf(" - %d", t);
      t = cl->next[t];
    }
    printf("\n");
  }
  printf("\n");
}
