/****************************************************************************

  graph.c : ս

  Programmed by Shuji Nakamura  2000-08-19

****************************************************************************/


#include <stdio.h>  /* NULL, stdin, printf(), sscanf(), fgets() */
#include <stdlib.h> /* calloc(), malloc(), free() */
#include "graph.h"


/* պΤߤǻޤ̵֤˽
** n : 
** g : չ¤ΤؤΥݥ
*/
void create_graph(int n, GRAPH *g)
{
  g->n = n;
  g->adjlist = (EDGE **)calloc(n, sizeof(EDGE *));
  g->range = (RANGE **)malloc(n * sizeof(RANGE *));
  g->tree = (TREE **)malloc(n * sizeof(TREE *));
}


/* դλޤ
** s : 
** t : 
** w : Ť
** g : չ¤ΤؤΥݥ
*/
static void insert_directed_edge(int s, int t, double w, GRAPH *g)
{
  EDGE *e;

  e = (EDGE *)malloc(sizeof(EDGE));
  e->next = g->adjlist[s];
  e->prev = NULL;
  e->node = t;
  e->weight = w;
  if(e->next != NULL)
    e->next->prev = e;
  g->adjlist[s] = e;
}


/* դξλޤ
** i, j : ޤξü
** w : ޤνŤ
** g : չ¤ΤؤΥݥ
*/
void insert_edge(int i, int j, double w, GRAPH *g)
{
  insert_directed_edge(i, j, w, g);
  insert_directed_edge(j, i, w, g);
}


/* դɸϤɤ߹
** g : չ¤ΤؤΥݥ
**  : 0, -1
*/
int input_graph(GRAPH *g)
{
  char buf[256], *ptr;
  int i, j, n, done, len;
  double w;

  /* ɤ߹ */
  if(!fgets(buf, sizeof buf, stdin))
    return -1;
  done = sscanf(buf, "%d", &n);
  if(done != 1 || n <= 0)
    return -1;

  /* պ */
  create_graph(++n, g);

  /* ޥǡɤ߹ */
  while(fgets(buf, sizeof buf, stdin) != NULL) {
    ptr = buf;
    do {
      done = sscanf(ptr, "%d%*[^0-9]%d%*[^0-9]%lf%*[^0-9]%n",
                    &i, &j, &w, &len);
      if(done < 3)
        break;
      if(i < 0 || i >= n || j < 0 || j >= n || w <= 0.0)
        return -1;
      insert_edge(i, j, w, g);
      ptr += len;
    } while(*ptr != '\0');
  }
  return 0;
}


/* դܥꥹȤι¤ɽ
** g : չ¤ΤؤΥݥ
*/
void print_graph(GRAPH *g)
{
  int i;
  EDGE *e;

  for(i = 0; i < g->n; i++) {
    printf("%d:", i);
    e = g->adjlist[i];
    while(e != NULL) {
      printf(" - %d", e->node);
      e = e->next;
    }
    printf("\n");
  }
  printf("\n");
}


/***************************************************************************/


/* եեպΤߤǻޤ̵֤˽
** n : 
** g : եեչ¤ΤؤΥݥ
*/
void create_graph_f(int n, GRAPH_F *g)
{
  g->n = n;
  g->adjlist = (EDGE_F **)calloc(n, sizeof(EDGE_F *));
}


/* եեդλޤ
** s : 
** t : 
** w : Ť
** g : եեչ¤ΤؤΥݥ
*/
void insert_directed_edge_f(int s, int t, double w, GRAPH_F *g)
{
  EDGE_F *e;

  e = (EDGE_F *)malloc(sizeof(EDGE_F));
  e->next = g->adjlist[s];
  e->prev = NULL;
  e->node = t;
  e->weight = w;
  e->flow = 0;
  if(e->next != NULL)
    e->next->prev = e;
  g->adjlist[s] = e;
}


/* եդդܥꥹȤι¤ɽ
** g : եդչ¤ΤؤΥݥ
*/
void print_graph_f(GRAPH_F *g)
{
  int i;
  EDGE_F *e;

  for(i = 0; i < g->n; i++) {
    printf("%d:", i);
    e = g->adjlist[i];
    while(e != NULL) {
      printf(" - %d", e->node);
      e = e->next;
    }
    printf("\n");
  }
  printf("\n");
}


/***************************************************************************/


/* ǽդպΤߤǻޤ̵֤˽
** n : 
** g : ǽդչ¤ΤؤΥݥ
*/
void create_graph_c(int n, GRAPH_C *g)
{
  g->n = g->ne = n;
  g->adjlist = (EDGE_C **)calloc(n, sizeof(EDGE_C *));
  g->state = (enum node_state *)calloc(n, sizeof(enum node_state));
  g->wbuf = (double *)calloc(n, sizeof(double));
  g->nto = (int *)malloc(n*sizeof(int));
  g->otn = (int *)malloc(n*sizeof(int));
  g->range = (RANGE **)malloc(n * sizeof(RANGE *));
  g->lamnum = (LAM_NUM **)malloc(n * sizeof(LAM_NUM *));
  g->tree = (TREE **)malloc(n * sizeof(TREE *));
}


/* ǽդդλޤ
** s : 
** t : 
** w : Ť
** g : ǽդչ¤ΤؤΥݥ
**  : ޹¤ΤؤΥݥ
*/
static EDGE_C *insert_directed_edge_c(int s, int t, double w, GRAPH_C *g)
{
  EDGE_C *e;

  e = (EDGE_C *)malloc(sizeof(EDGE_C));
  e->next = g->adjlist[s];
  e->prev = NULL;
  e->node = t;
  e->weight = w;
  e->reverse = NULL;
  if(e->next != NULL)
    e->next->prev = e;
  g->adjlist[s] = e;
  return e;
}


/* ǽդդξλޤ
** i, j : ޤξü
** w : ޤνŤ
** g : ǽդչ¤ΤؤΥݥ
*/
void insert_edge_c(int i, int j, double w, GRAPH_C *g)
{
  EDGE_C *e1, *e2;

  e1 = insert_directed_edge_c(i, j, w, g);
  e2 = insert_directed_edge_c(j, i, w, g);
  e1->reverse = e2;
  e2->reverse = e1;
}


/* ǽդդλޤ
** i : ޹¤Τ°ܥꥹȤֹ
** e : ޹¤ΤؤΥݥ
** g : ǽդչ¤ΤؤΥݥ
*/
void delete_edge_c(int i, EDGE_C *e, GRAPH_C *g)
{
  if(e->prev != NULL)
    e->prev->next = e->next;
  else
    g->adjlist[i] = e->next;
  if(e->next != NULL)
    e->next->prev = e->prev;

  free(e);
}


/* ǽդդ
** i : ֹ
** g : ǽդչ¤ΤؤΥݥ
*/
void delete_node_c(int i, GRAPH_C *g)
{
  EDGE_C *e, *t;

  if(g->state[i] == DELETED)
    return;

  e = g->adjlist[i];
  while(e != NULL) {
    t = e;
    e = e->next;
    if(t->reverse != NULL)
      delete_edge_c(t->node, t->reverse, g);
    delete_edge_c(i, t, g);
  }
  g->state[i] = DELETED;
  g->ne--;
}


/* ǽդդΣ󤹤
** s : ˺ֹ
** t : ˻Ĥֹ
** g : ǽդչ¤ΤؤΥݥ
*/
void contract_node_c(int s, int t, GRAPH_C *g)
{
  int i;
  EDGE_C *e;

  e = g->adjlist[t];
  while(e != NULL) {
    g->wbuf[e->node] = e->weight;
    e = e->next;
  }

  e = g->adjlist[s];
  while(e != NULL) {
    if(e->node != t) {
      if(g->wbuf[e->node] == 0)
        insert_edge_c(t, e->node, e->weight, g);
      g->wbuf[e->node] += e->weight;
    }
    e = e->next;
  }

  e = g->adjlist[t];
  while(e != NULL) {
    e->weight = e->reverse->weight = g->wbuf[e->node];
    g->wbuf[e->node] = 0;
    e = e->next;
  }

  delete_node_c(s, g);
}


/* ǽդդޤ̵֤˽
** g : ǽդչ¤ΤؤΥݥ
*/
void init_graph_c(GRAPH_C *g)
{
  int i;
  EDGE_C *e, *t;

  for(i = 0; i < g->n; i++) {
    e = g->adjlist[i];
    g->adjlist[i] = NULL;
    while(e != NULL) {
      t = e;
      e = e->next;
      free(t);
    }
    g->state[i] = EXIST;
  }
  g->ne = g->n;
}


/* ǽդդܥꥹȤι¤ɽ
** g : ǽդչ¤ΤؤΥݥ
*/
void print_graph_c(GRAPH_C *g)
{
  int i;
  EDGE_C *e;

  for(i = 0; i < g->n; i++) {
    printf("%d:", i);
    e = g->adjlist[i];
    while(e != NULL) {
      printf(" - %d (%2d)", e->node, (int)e->weight);
      e = e->next;
    }
    printf("\n");
  }
  printf("\n");
}


/***************************************************************************/


/* ǽդͭպΤߤǻޤ̵֤˽
** n : 
** g : ǽդͭչ¤ΤؤΥݥ
*/
void create_graph_d(int n, GRAPH_D *g)
{
  g->n = g->ne = n;
  g->adjlist = (EDGE_D **)calloc(n, sizeof(EDGE_D *));
  g->revlist = (EDGE_D **)calloc(n, sizeof(EDGE_D *));
  g->state = (enum node_state *)calloc(n, sizeof(enum node_state));
  g->wbuf = (double *)calloc(n, sizeof(double));
}


/* ǽդͭդλޤ
** s : 
** t : 
** w : Ť
** g : ǽդͭչ¤ΤؤΥݥ
*/
void insert_directed_edge_d(int s, int t, double w, GRAPH_D *g)
{
  EDGE_D *es, *et;

  es = (EDGE_D *)malloc(sizeof(EDGE_D));
  et = (EDGE_D *)malloc(sizeof(EDGE_D));

  es->next = g->adjlist[s];
  es->prev = NULL;
  es->node = t;
  es->weight = w;
  es->pair = et;
  if(es->next != NULL)
    es->next->prev = es;
  g->adjlist[s] = es;

  et->next = g->revlist[t];
  et->prev = NULL;
  et->node = s;
  et->weight = w;
  et->pair = es;
  if(et->next != NULL)
    et->next->prev = et;
  g->revlist[t] = et;
}


/* ǽդͭդλޤ
** i : ޹¤Τ°ܥꥹȡadjlistˤֹ
** e : ޹¤ΤؤΥݥ󥿡adjlist ¦
** g : ǽդͭչ¤ΤؤΥݥ
*/
void delete_edge_d(int i, EDGE_D *e, GRAPH_D *g)
{
  EDGE_D *t;

  if(e->prev != NULL)
    e->prev->next = e->next;
  else
    g->adjlist[i] = e->next;
  if(e->next != NULL)
    e->next->prev = e->prev;

  t = e->pair;
  if(t->prev != NULL)
    t->prev->next = t->next;
  else
    g->revlist[e->node] = t->next;
  if(t->next != NULL)
    t->next->prev = t->prev;

  free(e);
  free(t);
}


/* ǽդͭդ
** i : ֹ
** g : ǽդͭչ¤ΤؤΥݥ
*/
void delete_node_d(int i, GRAPH_D *g)
{
  EDGE_D *e, *t;

  if(g->state[i] == DELETED)
    return;

  e = g->adjlist[i];
  while(e != NULL) {
    t = e;
    e = e->next;
    delete_edge_d(i, t, g);
  }

  e = g->revlist[i];
  while(e != NULL) {
    t = e;
    e = e->next;
    delete_edge_d(t->node, t->pair, g);
  }

  g->state[i] = DELETED;
  g->ne--;
}


/* ǽդͭդ󤹤
** nn : 󤹤ο
** nbuf : 󤹤ֹnbuf[0] ˻Ĥ
** g : ǽդͭչ¤ΤؤΥݥ
*/
void contract_nodes_d(int nn, int nbuf[], GRAPH_D *g)
{
  int i, t = nbuf[0];
  EDGE_D *e;

  e = g->adjlist[t];
  while(e != NULL) {
    g->wbuf[e->node] = e->weight;
    e = e->next;
  }
  for(i = 1; i < nn; i++) {
    e = g->adjlist[nbuf[i]];
    while(e != NULL) {
      if(e->node != t) {
        if(g->wbuf[e->node] == 0)
          insert_directed_edge_d(t, e->node, e->weight, g);
        g->wbuf[e->node] += e->weight;
      }
      e = e->next;
    }
  }
  e = g->adjlist[t];
  while(e != NULL) {
    e->weight = e->pair->weight = g->wbuf[e->node];
    g->wbuf[e->node] = 0;
    e = e->next;
  }

  e = g->revlist[t];
  while(e != NULL) {
    g->wbuf[e->node] = e->weight;
    e = e->next;
  }
  for(i = 1; i < nn; i++) {
    e = g->revlist[nbuf[i]];
    while(e != NULL) {
      if(e->node != t) {
        if(g->wbuf[e->node] == 0)
          insert_directed_edge_d(e->node, t, e->weight, g);
        g->wbuf[e->node] += e->weight;
      }
      e = e->next;
    }
  }
  e = g->revlist[t];
  while(e != NULL) {
    e->weight = e->pair->weight = g->wbuf[e->node];
    g->wbuf[e->node] = 0;
    e = e->next;
  }

  for(i = 1; i < nn; i++)
    delete_node_d(nbuf[i], g);
}


/* ǽդͭդܥꥹȤι¤ɽ
** g : ǽդͭչ¤ΤؤΥݥ
*/
void print_graph_d(GRAPH_D *g)
{
  int i;
  EDGE_D *e;

  for(i = 0; i < g->n; i++) {
    printf("%d:", i);
    if(g->state[i] == DELETED)
      printf(" deleted");
    e = g->adjlist[i];
    while(e != NULL) {
      printf(" - %d", e->node);
      e = e->next;
    }
    printf("\n");
  }
  printf("\n");
}
