/****************************************************************************

  graph.h : ս

  Base Programmed by Shuji Nakamura  2000-08-19
  Arrange Programmed by Yuusuke Abe  2000-11-16

****************************************************************************/


/* ޹¤ */
typedef struct edge {
  int node;          /* ³ */
  double weight;     /* Ť */
  struct edge *prev; /*  */
  struct edge *next; /*  */
} EDGE;

/* LAMINAR¸2ʬڹ¤ */
typedef struct Tree{
  int vernum;              /* ֹ */
  double area[2];          /* 󥸤ιɬפϰ */
  struct Tree *right;      
  struct Tree *left;       /* Ҥȿ */
  struct Tree *parent;     
  enum vertex_state {
    LAM = 0, DUMMY = 1
  } Vstate;                /* LAMINAR°뤫(LAM:°, DUMMY:°ʤ) */  
  enum range_state {
    MATCH = 0, UNCONGENIAL = 1
  } Rstate;                /* ŪŬɽκݤΥå */

} TREE;

/* ѥꥹȹ¤ */
typedef struct range_c{
  double value;          /* 󥸤 */
  struct range_c *next;  /* ʣ󥸤μΥ󥸤ؤΥݥ */
} RANGE;                 /* ñΤξNULL                             */

typedef struct ht{
  struct range_c *top;
  struct range_c *tail;
} HT;

/* LAMINAR˴ޤޤĺֹ¸¤
   ݻ¤                  */
typedef struct lam_num{
  unsigned int number;
  struct lam_num *next;
} LAM_NUM;

/* LAMINARǻޤդ­ɬפϰϤ¸ꥹȹ¤ */
typedef struct Laminar{
   int k[3];       /* LAMINARǻޤդ­ɬפϰ¸ */
  struct lam_num *num;     /* LAMINAR˴ޤޤĺֹ */
  struct Laminar *next;    /* ʲLAMINARꥹȾ¸ */
} LAMINAR;

/* չ¤ */
typedef struct graph {
  int n;                    /*  */
  struct range_c **range;   /*  */
  struct Laminar *laminar; /* Laminar */
  struct Tree **tree;
  struct edge **adjlist;    /* ܥꥹ(޹¤ΤؤΥݥ󥿤) */
} GRAPH;

/* եդѻ޹¤ */
typedef struct edge_f {
  int node;              /* ³ */
  double weight;         /* Ť */
  struct edge_f *prev;   /*  */
  struct edge_f *next;   /*  */
  double flow;           /* ե */
} EDGE_F;

/* եդչ¤ */
typedef struct graph_f {
  int n;                   /*  */
  struct edge_f **adjlist; /* ܥꥹ */
} GRAPH_F;

/* ǽդѻ޹¤ */
typedef struct edge_c {
  int node;               /* ³ */
  double weight;          /* Ť */
  struct edge_c *prev;    /*  */
  struct edge_c *next;    /*  */
  struct edge_c *reverse; /* ոޥ */
} EDGE_C;

/* ǽդչ¤ */
typedef struct graph_c {
  int n;                   /*  */
  int ne;                  /* ¸ߤ */
  struct range_c **range;  /* ĺǤΥ */
  struct Laminar *laminar; /* Laminar */
  struct lam_num **lamnum; /* ν */
  struct Tree **tree;      /* LAMINAR */
  struct edge_c **adjlist; /* ܥꥹ(޹¤ΤؤΥݥ󥿤) */
  enum node_state {
    EXIST = 0, DELETED = 1
  } *state;                /* ξ(EXIST:¸ߤ, DELETED:Ѥ) */
  double *wbuf;            /* ѥХåե */
  int *otn;                /* ܽФֹ(order to node) */
  int *nto;                /* ֹФܽ(node to order) */
} GRAPH_C;

/* ǽդͭѻ޹¤ */
typedef struct edge_d {
  int node;            /* ³ */
  double weight;       /* Ť */
  struct edge_d *prev; /*  */
  struct edge_d *next; /*  */
  struct edge_d *pair; /* ոޥ */
} EDGE_D;

/* ǽդͭչ¤ */
typedef struct graph_d {
  int n;                   /*  */
  int ne;                  /* ¸ߤ */
  struct edge_d **adjlist; /* ܥꥹ(޹¤ΤؤΥݥ󥿤) */
  struct edge_d **revlist; /* ܥꥹ(޹¤ΤؤΥݥ󥿤) */
  enum node_state *state;  /* ξ(EXIST:¸ߤ, DELETED:Ѥ) */
  double *wbuf;            /* ѥХåե */
} GRAPH_D;


void create_graph(int n, GRAPH *g);
void insert_edge(int i, int j, double w, GRAPH *g);
int input_graph(GRAPH *g);
void print_graph(GRAPH *g);

void create_graph_f(int n, GRAPH_F *g);
void insert_directed_edge_f(int s, int t, double w, GRAPH_F *g);
void print_graph_f(GRAPH_F *g);

void create_graph_c(int n, GRAPH_C *g);
void insert_edge_c(int i, int j, double w, GRAPH_C *g);
void delete_edge_c(int i, EDGE_C *e, GRAPH_C *g);
void delete_node_c(int i, GRAPH_C *g);
void contract_node_c(int s, int t, GRAPH_C *g);
void init_graph_c(GRAPH_C *g);
void print_graph_c(GRAPH_C *g);

void create_graph_d(int n, GRAPH_D *g);
void insert_directed_edge_d(int s, int t, double w, GRAPH_D *g);
void contract_nodes_d(int nn, int nbuf[], GRAPH_D *g);
void print_graph_d(GRAPH_D *g);
