/****************************************************************************

  heap.c : ҡ׽

  Programmed by Shuji Nakamura  2000-08-17

****************************************************************************/


#include <stdio.h>  /* printf() */
#include <stdlib.h> /* malloc(), free() */
#include "heap.h"


/* ҡ׺
** n : ǿ
** h : ҡ׹¤ΤؤΥݥ
*/
void create_heap(int n, HEAP *h)
{
  int i;

  /*  */
  h->n = 0;
  h->max = n;
  h->node = (int *)malloc(n*sizeof(int));
  h->pos = (int *)malloc(n*sizeof(int));
  h->key = (double *)malloc(n*sizeof(double));

  /*  */
  for(i = 0; i < n; i++)
    h->pos[i] = -1;
}


/* ҡ׳
** h : ҡ׹¤ΤؤΥݥ
*/
void free_heap(HEAP *h)
{
  free(h->node);
  free(h->pos);
  free(h->key);
}


/*  key ֹ֤
** h : ҡ׹¤ΤؤΥݥ
*/
int find_max(HEAP *h)
{
  return h->node[0];
}


/* Ǹ
** i, j : 򴹤ǤΥҡ׾ΰ
** h : ҡ׹¤ΤؤΥݥ
*/
static void swap(int i, int j, HEAP *h)
{
  int t;

  t = h->node[i], h->node[i] = h->node[j], h->node[j] = t;
  h->pos[h->node[i]] = i;
  h->pos[h->node[j]] = j;
}


/* ˸äƥҡ׾
** i : Ϥҡ׾ΰ
** h : ҡ׹¤ΤؤΥݥ
*/
static void down_heap(int i, HEAP *h)
{
  int j;

  while(i*2+1 < h->n) {
    j = i*2+1;
    if(j+1 < h->n && h->key[h->node[j]] < h->key[h->node[j+1]])
      j++;
    if(h->key[h->node[i]] >= h->key[h->node[j]])
      break;
    swap(i, j, h);
    i = j;
  }
}


/* ˸äƥҡ׾
** i : Ϥҡ׾ΰ
** h : ҡ׹¤ΤؤΥݥ
*/
static void up_heap(int i, HEAP *h)
{
  int j;

  while(i > 0) {
    j = (i-1)/2;
    if(h->key[h->node[i]] <= h->key[h->node[j]])
      break;
    swap(i, j, h);
    i = j;
  }
}


/* ֹ i Ǥҡפ
** i : ֹ
** key : 
** h : ҡ׹¤ΤؤΥݥ
*/
void insert_heap(int i, double key, HEAP *h)
{
  h->node[h->n] = i;
  h->pos[i] = h->n;
  h->key[i] = key;
  up_heap(h->n, h);
  h->n++;
}


/*  key 줿ֹ֤
** h : ҡ׹¤ΤؤΥݥ
*/
int delete_max(HEAP *h)
{
  if(h->n == 0)
    return -1;

  /*  */
  h->n--;
  swap(0, h->n, h);

  /* ҡ׾ */
  down_heap(0, h);

  /* Ѥߤ򼨤 */
  h->pos[h->node[h->n]] = -1;

  return h->node[h->n];
}


/* ֹ i  key  d ä
** i : ֹ
** d : ä
** h : ҡ׹¤ΤؤΥݥ
*/
void increase_key(int i, double d, HEAP *h)
{
  /* Ѥߤʤ齪λ */
  if(h->pos[i] == -1)
    return;

  /*  */
  h->key[i] += d;

  /* ҡ׾ */
  up_heap(h->pos[i], h);
}


/* ҡˤ뤫å
** i : ֹ
** h : ҡפؤι¤
*/
int member(int i, HEAP *h)
{
  return h->pos[i] != -1;
}


/* ҡפι¤ɽ */
void print_heap(HEAP *h)
{
  int i;

  for(i = 0; i < h->n; i++)
    printf("%d: node=%d key=%f pos=%d\n",
           i, h->node[i], h->key[h->node[i]], h->pos[h->node[i]]);
  printf("\n");
}
